import { NzAffixModule } from 'ant-reset-private/affix';
export { NzAffixComponent, NzAffixModule } from 'ant-reset-private/affix';
import { NzAlertModule } from 'ant-reset-private/alert';
export { NzAlertComponent, NzAlertModule } from 'ant-reset-private/alert';
import { NzAnchorModule } from 'ant-reset-private/anchor';
export { NzAnchorLinkComponent, NzAnchorComponent, NzAnchorModule } from 'ant-reset-private/anchor';
import { NzAutocompleteModule } from 'ant-reset-private/auto-complete';
export { NzAutocompleteModule, NzAutocompleteComponent, getNzAutocompleteMissingPanelError, NZ_AUTOCOMPLETE_VALUE_ACCESSOR, NzAutocompleteTriggerDirective, NzOptionSelectionChange, NzAutocompleteOptionComponent, NzAutocompleteOptgroupComponent } from 'ant-reset-private/auto-complete';
import { NzAvatarModule } from 'ant-reset-private/avatar';
export { NzAvatarComponent, NzAvatarModule } from 'ant-reset-private/avatar';
import { NzBackTopModule } from 'ant-reset-private/back-top';
export { NzBackTopComponent, NzBackTopModule } from 'ant-reset-private/back-top';
import { NzBadgeModule } from 'ant-reset-private/badge';
export { NzBadgeComponent, NzBadgeModule } from 'ant-reset-private/badge';
import { NzBreadCrumbModule } from 'ant-reset-private/breadcrumb';
export { NzBreadCrumbItemComponent, NZ_ROUTE_DATA_BREADCRUMB, NzBreadCrumbComponent, NzBreadCrumbModule } from 'ant-reset-private/breadcrumb';
import { NzButtonModule } from 'ant-reset-private/button';
export { NzButtonComponent, NzButtonGroupComponent, NzButtonModule } from 'ant-reset-private/button';
import { NzCalendarModule } from 'ant-reset-private/calendar';
export { NzCalendarModule, NzCalendarComponent, NzDateCellDirective, NzMonthCellDirective, NzDateFullCellDirective, NzMonthFullCellDirective, NzCalendarHeaderComponent } from 'ant-reset-private/calendar';
import { NzCardModule } from 'ant-reset-private/card';
export { NzCardGridDirective, NzCardComponent, NzCardModule, NzCardLoadingComponent, NzCardMetaComponent, NzCardTabComponent } from 'ant-reset-private/card';
import { NzCarouselModule } from 'ant-reset-private/carousel';
export { NzCarouselModule, NzCarouselComponent, NzCarouselContentDirective, NZ_CAROUSEL_CUSTOM_STRATEGIES, NzCarouselBaseStrategy } from 'ant-reset-private/carousel';
import { NzCascaderModule } from 'ant-reset-private/cascader';
export { isShowSearchObject, isChildOption, isParentOption, NzCascaderComponent, NzCascaderModule, NzCascaderService, NzCascaderOptionComponent } from 'ant-reset-private/cascader';
import { NzCheckboxModule } from 'ant-reset-private/checkbox';
export { NzCheckboxComponent, NzCheckboxModule, NzCheckboxGroupComponent, NzCheckboxWrapperComponent } from 'ant-reset-private/checkbox';
import { NzCollapseModule } from 'ant-reset-private/collapse';
export { NzCollapsePanelComponent, NzCollapseComponent, NzCollapseModule } from 'ant-reset-private/collapse';
import { NzCommentModule } from 'ant-reset-private/comment';
export { NzCommentModule, NzCommentComponent, NzCommentAvatarDirective, NzCommentContentDirective, NzCommentActionHostDirective, NzCommentActionComponent } from 'ant-reset-private/comment';
import { NzNoAnimationModule, NzWaveModule } from 'ant-reset-private/core';
export { NzAddOnModule, NzClassListAddDirective, NzStringTemplateOutletDirective, AnimationDuration, AnimationCurves, collapseMotion, fadeMotion, helpMotion, moveUpMotion, notificationMotion, slideMotion, slideAlertMotion, zoomMotion, zoomBigMotion, zoomBadgeMotion, NzNoAnimationModule, NzNoAnimationDirective, NzConnectedOverlayDirective, NzOverlayModule, getPlacementName, POSITION_MAP, DEFAULT_TOOLTIP_POSITIONS, DEFAULT_DROPDOWN_POSITIONS, DEFAULT_SUBMENU_POSITIONS, DEFAULT_CASCADER_POSITIONS, DEFAULT_MENTION_POSITIONS, cancelRequestAnimationFrame, reqAnimFrame, SCROLL_SERVICE_PROVIDER_FACTORY, NzScrollService, SCROLL_SERVICE_PROVIDER, NzMeasureScrollbarService, NzUpdateHostClassService, dispatchEvent, dispatchFakeEvent, dispatchKeyboardEvent, dispatchMouseEvent, dispatchTouchEvent, createMouseEvent, createTouchEvent, createKeyboardEvent, createFakeEvent, typeInElement, wrappedErrorMessage, FakeViewportRuler, MockNgZone, NzTreeNode, NzTreeBaseService, NzTreeHigherOrderServiceToken, NzTreeBase, toArray, arraysEqual, shallowCopyArray, isNotNil, isNil, shallowEqual, isInteger, isEmpty, filterNotEmptyNode, isNonEmptyString, isTemplateRef, isComponent, toBoolean, toNumber, toCssPixel, valueFunctionProp, InputBoolean, InputCssPixel, InputNumber, silentEvent, getElementOffset, findFirstNotEmptyNode, findLastNotEmptyNode, reverseChildNodes, isTouchEvent, getRegExp, getMentions, padStart, padEnd, getRepeatedElement, isPromise, getPercent, getPrecision, ensureNumberInRange, scrollIntoView, getCaretCoordinates, createDebugEle, properties, throttleByAnimationFrameDecorator, timeUnits, ensureInBounds, NzWaveRenderer, NZ_WAVE_GLOBAL_CONFIG_FACTORY, NZ_WAVE_GLOBAL_DEFAULT_CONFIG, NZ_WAVE_GLOBAL_CONFIG, NzWaveDirective, NzWaveModule, NzMenuBaseService, NzDropdownHigherOrderServiceToken, LoggerModule, LoggerService, NZ_LOGGER_STATE, LOGGER_SERVICE_PROVIDER, LOGGER_SERVICE_PROVIDER_FACTORY, Breakpoint, responsiveMap } from 'ant-reset-private/core';
import { NzDatePickerModule } from 'ant-reset-private/date-picker';
export { ɵp, ɵo, ɵr, ɵd, ɵb, ɵc, ɵe, ɵf, ɵg, ɵh, ɵl, ɵa, ɵj, ɵk, ɵn, ɵm, ɵi, ɵq, CandyDate, NzDatePickerModule, NzDatePickerComponent, NzRangePickerComponent, NzMonthPickerComponent, NzWeekPickerComponent, NzYearPickerComponent } from 'ant-reset-private/date-picker';
import { NzDescriptionsModule } from 'ant-reset-private/descriptions';
export { NzDescriptionsModule, NzDescriptionsComponent, NzDescriptionsItemComponent } from 'ant-reset-private/descriptions';
import { NzDividerModule } from 'ant-reset-private/divider';
export { NzDividerComponent, NzDividerModule } from 'ant-reset-private/divider';
import { NzDrawerModule } from 'ant-reset-private/drawer';
export { DRAWER_ANIMATE_DURATION, NzDrawerComponent, NzDrawerModule, DrawerBuilderForService, NzDrawerService, NzDrawerRef } from 'ant-reset-private/drawer';
import { NzDropDownModule } from 'ant-reset-private/dropdown';
export { NzDropdownContextComponent, menuServiceFactory, NzDropDownComponent, NzDropDownDirective, NzDropdownService, NzDropDownButtonComponent, NzDropDownModule, NzMenuDropdownService, NzDropDownADirective } from 'ant-reset-private/dropdown';
import { NzEmptyModule } from 'ant-reset-private/empty';
export { NzEmbedEmptyComponent, NzEmptyComponent, NzEmptyModule, NzEmptyService, NZ_DEFAULT_EMPTY_CONTENT, NZ_EMPTY_COMPONENT_NAME, emptyImage, simpleEmptyImage } from 'ant-reset-private/empty';
import { NzFormModule } from 'ant-reset-private/form';
export { NzFormModule, NzFormDirective, NzFormControlComponent, NzFormExplainComponent, NzFormItemComponent, NzFormExtraComponent, NzFormLabelComponent, NzFormSplitComponent, NzFormTextComponent } from 'ant-reset-private/form';
import { NzGridModule } from 'ant-reset-private/grid';
export { NzRowDirective, NzColDirective, NzGridModule } from 'ant-reset-private/grid';
import { NzI18nModule } from 'ant-reset-private/i18n';
export { NzI18nModule, NzI18nService, NZ_DATE_CONFIG, ar_EG, bg_BG, ca_ES, cs_CZ, da_DK, de_DE, el_GR, en_GB, en_US, es_ES, et_EE, fa_IR, fi_FI, fr_BE, fr_FR, is_IS, it_IT, ja_JP, ko_KR, nb_NO, nl_BE, nl_NL, pl_PL, pt_BR, pt_PT, ru_RU, sk_SK, sl_SI, sr_RS, sv_SE, th_TH, tr_TR, uk_UA, vi_VN, zh_CN, zh_TW, NZ_I18N, NZ_DATE_LOCALE, DATE_HELPER_SERVICE_FACTORY, DateHelperService, DateHelperByDateFns, DateHelperByDatePipe, NzI18nPipe } from 'ant-reset-private/i18n';
import { NzIconModule } from 'ant-reset-private/icon';
export { NzIconModule, NzIconDirective, NZ_ICONS, NZ_ICON_DEFAULT_TWOTONE_COLOR, DEFAULT_TWOTONE_COLOR, NZ_ICONS_USED_BY_ZORRO, NzIconService } from 'ant-reset-private/icon';
import { NzInputModule } from 'ant-reset-private/input';
export { NzInputGroupComponent, NzInputModule, NzInputDirective, isAutoSizeType, NzAutosizeDirective } from 'ant-reset-private/input';
import { NzInputNumberModule } from 'ant-reset-private/input-number';
export { NzInputNumberComponent, NzInputNumberModule } from 'ant-reset-private/input-number';
import { NzLayoutModule } from 'ant-reset-private/layout';
export { NzContentComponent, NzFooterComponent, NzHeaderComponent, NzLayoutComponent, NzSiderComponent, NzLayoutModule } from 'ant-reset-private/layout';
import { NzListModule } from 'ant-reset-private/list';
export { NzListItemMetaComponent, NzListItemComponent, NzListComponent, NzListModule } from 'ant-reset-private/list';
import { NzMentionModule } from 'ant-reset-private/mention';
export { NzMentionModule, NzMentionComponent, NZ_MENTION_TRIGGER_ACCESSOR, NzMentionTriggerDirective, NzMentionSuggestionDirective } from 'ant-reset-private/mention';
import { NzMenuModule } from 'ant-reset-private/menu';
export { NzMenuDirective, NzMenuGroupComponent, NzMenuDividerDirective, NzMenuItemDirective, NzSubMenuComponent, NzMenuModule, NzMenuService, NzSubmenuService, NzMenuServiceFactory } from 'ant-reset-private/menu';
import { NzMessageModule } from 'ant-reset-private/message';
export { NzMessageBaseService, NzMessageService, NzMessageModule, NzMessageComponent, NzMessageContainerComponent, NZ_MESSAGE_DEFAULT_CONFIG, NZ_MESSAGE_CONFIG, NZ_MESSAGE_DEFAULT_CONFIG_PROVIDER } from 'ant-reset-private/message';
import { NzModalModule } from 'ant-reset-private/modal';
export { NzModalComponent, NzModalRef, NzModalModule, NzModalService, NZ_MODAL_CONFIG, NzModalControlService, CssUnitPipe } from 'ant-reset-private/modal';
import { NzNotificationModule } from 'ant-reset-private/notification';
export { NZ_NOTIFICATION_DEFAULT_CONFIG, NZ_NOTIFICATION_CONFIG, NZ_NOTIFICATION_DEFAULT_CONFIG_PROVIDER, NzNotificationComponent, NzNotificationModule, NzNotificationService, NzNotificationContainerComponent } from 'ant-reset-private/notification';
import { NzPageHeaderModule } from 'ant-reset-private/page-header';
export { NzPageHeaderModule, NzPageHeaderComponent, NzPageHeaderTitleDirective, NzPageHeaderSubtitleDirective, NzPageHeaderContentDirective, NzPageHeaderTagDirective, NzPageHeaderExtraDirective, NzPageHeaderFooterDirective, NzPageHeaderBreadcrumbDirective } from 'ant-reset-private/page-header';
import { NzPaginationModule } from 'ant-reset-private/pagination';
export { NzPaginationComponent, NzPaginationModule } from 'ant-reset-private/pagination';
import { NzPopconfirmModule } from 'ant-reset-private/popconfirm';
export { NzPopconfirmComponent, NzPopconfirmDirective, NzPopconfirmModule } from 'ant-reset-private/popconfirm';
import { NzPopoverModule } from 'ant-reset-private/popover';
export { NzPopoverComponent, NzPopoverDirective, NzPopoverModule } from 'ant-reset-private/popover';
import { NzProgressModule } from 'ant-reset-private/progress';
export { NzProgressModule, NzProgressComponent } from 'ant-reset-private/progress';
import { NzRadioModule } from 'ant-reset-private/radio';
export { NzRadioButtonComponent, NzRadioGroupComponent, NzRadioComponent, NzRadioModule } from 'ant-reset-private/radio';
import { NzRateModule } from 'ant-reset-private/rate';
export { NzRateComponent, NzRateModule, NzRateItemComponent } from 'ant-reset-private/rate';
import { NzResizableModule } from 'ant-reset-private/resizable';
export { NzResizableModule, NzResizableDirective, NzResizableService, DEFAULT_RESIZE_DIRECTION, NzResizeHandlesComponent, NzResizeHandleMouseDownEvent, NzResizeHandleComponent, getEventWithPoint } from 'ant-reset-private/resizable';
import { NzSelectModule } from 'ant-reset-private/select';
export { NzOptionGroupComponent, NzOptionContainerComponent, NzOptionComponent, NzSelectComponent, NzSelectModule, NzOptionLiComponent, defaultFilterOption, NzFilterOptionPipe, NzFilterGroupOptionPipe, NzSelectTopControlComponent, NzSelectUnselectableDirective, NzSelectService } from 'ant-reset-private/select';
import { NzSkeletonModule } from 'ant-reset-private/skeleton';
export { NzSkeletonComponent, NzSkeletonModule } from 'ant-reset-private/skeleton';
import { NzSliderModule } from 'ant-reset-private/slider';
export { NzSliderComponent, NzSliderModule, NzSliderHandleComponent, NzSliderMarksComponent, NzSliderStepComponent, NzSliderTrackComponent, isValueARange, isConfigAObject, Marks } from 'ant-reset-private/slider';
import { NzSpinModule } from 'ant-reset-private/spin';
export { NzSpinComponent, NzSpinModule } from 'ant-reset-private/spin';
import { NzStatisticModule } from 'ant-reset-private/statistic';
export { NzCountdownComponent, NzStatisticComponent, NzStatisticModule, NzStatisticNumberComponent, NzTimeRangePipe } from 'ant-reset-private/statistic';
import { NzStepsModule } from 'ant-reset-private/steps';
export { NzStepsComponent, NzStepComponent, NzStepsModule } from 'ant-reset-private/steps';
import { NzSwitchModule } from 'ant-reset-private/switch';
export { NzSwitchComponent, NzSwitchModule } from 'ant-reset-private/switch';
import { NzTableModule } from 'ant-reset-private/table';
export { NzTableComponent, NzTableModule, NzTbodyDirective, NzTdComponent, NzThComponent, NzTheadComponent, NzTrDirective, NzVirtualScrollDirective } from 'ant-reset-private/table';
import { NzTabsModule } from 'ant-reset-private/tabs';
export { NzTabBodyComponent, NzTabLabelDirective, NzTabComponent, NzTabsInkBarDirective, NzTabsModule, NzTabsNavComponent, NzTabChangeEvent, NzTabSetComponent, NzTabDirective } from 'ant-reset-private/tabs';
import { NzTagModule } from 'ant-reset-private/tag';
export { NzTagComponent, NzTagModule } from 'ant-reset-private/tag';
import { NzTimePickerModule } from 'ant-reset-private/time-picker';
export { NzTimePickerComponent, NzTimePickerModule, NzTimePickerPanelComponent, NzTimeValueAccessorDirective } from 'ant-reset-private/time-picker';
import { NzTimelineModule } from 'ant-reset-private/timeline';
export { NzTimelineItemComponent, NzTimelineComponent, NzTimelineModule } from 'ant-reset-private/timeline';
import { NzToolTipModule } from 'ant-reset-private/tooltip';
export { NzToolTipComponent, NzTooltipDirective, NzToolTipModule } from 'ant-reset-private/tooltip';
import { NzTransferModule } from 'ant-reset-private/transfer';
export { NzTransferListComponent, NzTransferSearchComponent, NzTransferComponent, NzTransferModule } from 'ant-reset-private/transfer';
import { NzTreeModule } from 'ant-reset-private/tree';
export { NzTreeModule, NzTreeServiceFactory, NzTreeComponent, NzTreeNodeComponent, NzTreeService } from 'ant-reset-private/tree';
import { NzTreeSelectModule } from 'ant-reset-private/tree-select';
export { higherOrderServiceFactory, NzTreeSelectComponent, NzTreeSelectModule, NzTreeSelectService } from 'ant-reset-private/tree-select';
import { NzUploadModule } from 'ant-reset-private/upload';
export { NzUploadBtnComponent, NzUploadListComponent, NzUploadComponent, NzUploadModule } from 'ant-reset-private/upload';
import { Version, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var VERSION = new Version('7.6.2');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgZorroAntdModule = /** @class */ (function () {
    function NgZorroAntdModule() {
    }
    /**
     * @deprecated Use `NgZorroAntdModule` instead.
     */
    /**
     * @deprecated Use `NgZorroAntdModule` instead.
     * @return {?}
     */
    NgZorroAntdModule.forRoot = /**
     * @deprecated Use `NgZorroAntdModule` instead.
     * @return {?}
     */
    function () {
        return {
            ngModule: NgZorroAntdModule
        };
    };
    NgZorroAntdModule.decorators = [
        { type: NgModule, args: [{
                    exports: [
                        NzButtonModule,
                        NzCalendarModule,
                        NzGridModule,
                        NzSwitchModule,
                        NzSelectModule,
                        NzMenuModule,
                        NzMentionModule,
                        NzAnchorModule,
                        NzAffixModule,
                        NzDropDownModule,
                        NzLayoutModule,
                        NzBreadCrumbModule,
                        NzPaginationModule,
                        NzStepsModule,
                        NzInputModule,
                        NzCheckboxModule,
                        NzInputNumberModule,
                        NzSliderModule,
                        NzRateModule,
                        NzBadgeModule,
                        NzRadioModule,
                        NzAlertModule,
                        NzSpinModule,
                        NzPageHeaderModule,
                        NzProgressModule,
                        NzTabsModule,
                        NzIconModule,
                        NzCardModule,
                        NzAvatarModule,
                        NzTimelineModule,
                        NzTransferModule,
                        NzCarouselModule,
                        NzCollapseModule,
                        NzCommentModule,
                        NzTableModule,
                        NzDatePickerModule,
                        NzDividerModule,
                        NzDrawerModule,
                        NzFormModule,
                        NzListModule,
                        NzI18nModule,
                        NzUploadModule,
                        NzAutocompleteModule,
                        NzTagModule,
                        NzMessageModule,
                        NzNotificationModule,
                        NzPopoverModule,
                        NzToolTipModule,
                        NzPopconfirmModule,
                        NzModalModule,
                        NzBackTopModule,
                        NzCascaderModule,
                        NzTreeModule,
                        NzTreeSelectModule,
                        NzTimePickerModule,
                        NzWaveModule,
                        NzNoAnimationModule,
                        NzSkeletonModule,
                        NzStatisticModule,
                        NzEmptyModule,
                        NzDescriptionsModule,
                        NzResizableModule
                    ]
                },] }
    ];
    return NgZorroAntdModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgZorroAntdModule, VERSION };

//# sourceMappingURL=ant-reset-private.js.map