import { AfterContentInit, AfterViewInit, ChangeDetectorRef, ElementRef, OnDestroy, OnInit, Renderer2 } from '@angular/core';
import { FormControl, FormControlName, NgModel } from '@angular/forms';
import { Subscription } from 'rxjs';
import { NgClassType, NzUpdateHostClassService } from 'ant-reset-private/core';
import { NzColDirective, NzRowDirective } from 'ant-reset-private/grid';
import { NzFormItemComponent } from './nz-form-item.component';
export declare class NzFormControlComponent extends NzColDirective implements OnDestroy, OnInit, AfterContentInit, AfterViewInit, OnDestroy {
    private cdr;
    private _hasFeedback;
    validateChanges: Subscription | null;
    validateString: string | null;
    status: 'warning' | 'validating' | 'error' | 'success' | 'init';
    controlClassMap: NgClassType;
    iconType: string;
    validateControl: FormControl | NgModel | null;
    defaultValidateControl: FormControlName;
    nzHasFeedback: boolean;
    nzValidateStatus: string | FormControl | FormControlName | NgModel;
    removeSubscribe(): void;
    watchControl(): void;
    validateControlStatus(status: string): boolean;
    setControlClassMap(): void;
    constructor(nzUpdateHostClassService: NzUpdateHostClassService, elementRef: ElementRef, nzFormItemComponent: NzFormItemComponent, nzRowDirective: NzRowDirective, cdr: ChangeDetectorRef, renderer: Renderer2);
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
}
